﻿Type=Class
Version=3.82
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private accfolder,accfile As String
	Private factory , twitter4j , requestToken , accesstoken As JavaObject
	Private caller_obj As Object
	Private success_init As String
	Private key,secret As String
End Sub
'Initializes the object. You can add parameters to this method if needed.
'success_init: the sub called after getting the accesstoken
Public Sub Initialize(callerobject As Object,consumerkey As String,consumersecret As String,accesstokendir As String,accesstokenfile As String,success_ini As String) As String
	caller_obj=callerobject
	success_init=success_ini
	key=consumerkey
	secret=consumersecret
	Dim thready As Thread
	thready.Initialise("")
	thready.Start(Me,"Real_Initialize",Array(callerobject,consumerkey,consumersecret,accesstokendir,accesstokenfile,success_ini))

End Sub
Public Sub Real_Initialize(callerobject As Object,consumerkey As String,consumersecret As String,accesstokendir As String,accesstokenfile As String,success_ini As String) As String
	
	factory.InitializeStatic("twitter4j.TwitterFactory")
	twitter4j=factory.RunMethod("getSingleton",Null)
	

	accfolder=accesstokendir
	accfile=accesstokenfile
	If File.Exists(accesstokendir,accesstokenfile) Then
		LoadAccessToken		
	Else

		Dim url As String
		twitter4j.RunMethod("setOAuthConsumer",Array(consumerkey,consumersecret))
		requestToken=twitter4j.RunMethod("getOAuthRequestToken",Null)

		url=requestToken.RunMethod("getAuthenticationURL",Null)
		Log(url)
		If url.Length>0 Then
			If SubExists(Main,"OpenBrowser") Then
				CallSubDelayed2(Main,"OpenBrowser",url)
				Return url
			End If
		
		Else
			'Error Getting Authorization URL
		End If




	End If

End Sub
Private Sub LoadAccessToken
	Dim acclist As List
	acclist.Initialize
	acclist=File.ReadList(accfolder,accfile)
	twitter4j.RunMethod("setOAuthConsumer",Array(key,secret))
	
	accesstoken.InitializeNewInstance("twitter4j.auth.AccessToken",Array(acclist.Get(0),acclist.Get(1)))
	twitter4j.RunMethod("setOAuthAccessToken",Array(accesstoken))
End Sub
Public Sub TokenExists As Boolean
	If File.Exists(accfolder,accfile) Then
		Return True
	Else
		Return False
	End If
End Sub
Public Sub SetAuth(code As String)
	Dim auththread As Thread
	auththread.Initialise("thre")
	auththread.Start(Me,"SetAuth_Thread",Array(code))
End Sub

Private Sub SetAuth_Thread(code As String)
	accesstoken = twitter4j.RunMethod("getOAuthAccessToken",Array(requestToken, code))
	File.WriteList(accfolder,accfile,Array(accesstoken.RunMethod("getToken",Null),accesstoken.RunMethod("getTokenSecret",Null)))

	
End Sub


Public Sub Tweet(TweetText As String)
	Dim TweeThread As Thread
	TweeThread.Initialise("")
	TweeThread.Start(Me,"Tweet_Thread",Array(TweetText))
End Sub
Private Sub Tweet_Thread(mweet As String)
	twitter4j.RunMethod("updateStatus",Array(mweet))

End Sub

Private Sub thre_Ended(fail As Boolean, error As String) 
	Log("ENDED")
	Log(caller_obj)
	Log(success_init)
	If error.Length>0 Then
		Log(error)
	Else
		If SubExists(caller_obj,success_init) Then
		Log("FOUND")
			CallSubDelayed(caller_obj,success_init)
		End If		
	End If
End Sub
